package program;

import dámy.Řešitel;

import java.io.IOException;
import java.util.Timer;
import java.util.TimerTask;

class Úloha extends TimerTask
{
    public Úloha(int početDam, Timer časovač)
    {
        řešitel = new Řešitel(početDam);
        this.časovač = časovač;
    }

    @Override
    public void run()
    {
        if (řešitel.najdiDalšíŘešení())
        {
            řešitel.výpis();
        }
        else
        {
            System.out.println("Toť vše.");
            časovač.cancel();
        }
    }

    private Řešitel řešitel;
    private Timer časovač;
}

class Čekatel implements Runnable
{
    public Čekatel(Timer časovač)
    {
        this.časovač = časovač;
        podproces = new Thread(this);
        podproces.setDaemon(true);
    }

    @Override
    public void run()
    {
        try
        {
            System.in.read();
        }
        catch(Exception ex)
        {
            // Úmyslně prázdná obsluha
        }
        časovač.cancel();
        System.out.println("Podle rozkazu končíme");
    }

    public void čekej()
    {
        podproces.start();
    }
    private Timer časovač;
    private Thread podproces;
}

public class Program
{
    public static void main(String[] param) throws IOException, InterruptedException {
        int n = 5;
        int interval = 2000;
        int odklad = 500;
        Timer časovač = new Timer(false);
        Čekatel čekatel = new Čekatel(časovač);
        čekatel.čekej();
        System.out.println("Řešení úlohy " + n + " dam:");
        System.out.println("Program ukončíte stiskem klávesy Enter.");
        časovač.scheduleAtFixedRate(new Úloha(n, časovač), odklad, interval);
    }
}
