package program;

import dámy.Řešitel;
import nástroje.Fond;

import java.util.ArrayList;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;

class Úloha implements Callable<int[]>
{
    private Řešitel řešitel;
    private int řádka;

    public Úloha(int početDam, int řádka)
    {
        this.řádka = řádka;
        řešitel = new Řešitel(početDam);
    }
    @Override
    public int[] call() throws Exception
    {
        if(řešitel.najdiDalšíŘešeníOdŘádky(řádka))
        {
            return řešitel.getŘešení();
        }
        else
        {
            return null;
        }
    }
}

public class Program
{
    public static void zpracujŘešení(int[] pole)
    {
        StringBuilder výpis = new StringBuilder("(");
        for(int i = 0; i < pole.length; i++)
        {
            výpis.append(pole[i]).append(i == pole.length-1? "" : ", ");
        }
        výpis.append(")");
        System.out.println(výpis);
    }

    public static void main(String[] param) throws InterruptedException, ExecutionException
    {
        int početDam = 15;
        ArrayList<Future<int[]>> výsledky = new ArrayList<>();
        Fond<int[]> fond = new Fond<>();
        for(int i = 0; i < početDam; i++)
        {
            výsledky.add(fond.zadej(new Úloha(početDam, i)));
        }
        fond.uzavřiAČekej();
        for(var výsledek: výsledky)
        {
            var řešení = výsledek.get();
            if(řešení != null)
            {
                zpracujŘešení(řešení);
            }
        }
    }
}
