package program;

import dámy.Řešitel;
import nástroje.Fond;

import java.util.ArrayList;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

public class Program
{
    public static void zpracujŘešení(int[] pole)
    {
        StringBuilder výpis = new StringBuilder("(");
        for(int i = 0; i < pole.length; i++)
        {
            výpis.append(pole[i]).append(i == pole.length-1? "" : ", ");
        }
        výpis.append(")");
        System.out.println(výpis);
    }

    private static int i;
    public static void main(String[] param) throws InterruptedException, ExecutionException
    {
        int početDam = 15;
        ArrayList<Future<int[]>> výsledky;
        Fond<int[]> fond = new Fond<>();
        výsledky = IntStream.range(0, početDam).mapToObj(i -> fond.zadej(() -> {
            Řešitel řešitel = new Řešitel(početDam);
            if(řešitel.najdiDalšíŘešeníOdŘádky(i))
                return řešitel.getŘešení();
            else
                return null;
        })).collect(Collectors.toCollection(ArrayList::new));
        fond.uzavřiAČekej();
        for(var výsledek: výsledky)
        {
            var řešení = výsledek.get();
            if(řešení != null)
            {
                zpracujŘešení(řešení);
            }
        }
    }
}
