package program;

import java.util.ArrayList;
import java.util.concurrent.*;
import java.util.function.Supplier;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import dámy.Řešitel;

class Úloha implements Callable<int[]>
{
    int početDam;
    int řádka;
    public Úloha(int početDam, int řádka)
    {
        this.početDam = početDam;
        this.řádka = řádka;
    }
    @Override
    public int[] call() throws Exception
    {
        Řešitel řešitel = new Řešitel(početDam);
        if(řešitel.najdiDalšíŘešeníOdŘádky(řádka))
        {
            return řešitel.getŘešení();
        }
        else
        {
                return  null;
        }
    }
}

public class Program
{
    public static void zpracujŘešení(int[] pole)
    {
        StringBuilder výpis = new StringBuilder("(");
        for(int i = 0; i < pole.length; i++)
        {
            výpis.append(pole[i]).append(i == pole.length-1? "" : ", ");
        }
        výpis.append(")");
        System.out.println(výpis);
    }

    public static void main(String[] param) throws InterruptedException, ExecutionException
    {
        int početDam = 8;
        ArrayList<Future<int[]>> výsledky = new ArrayList<>();
        var fond = Executors.newFixedThreadPool(Runtime.getRuntime().availableProcessors());
        for(int řádka = 0; řádka < početDam; řádka++)
        {
            výsledky.add(fond.submit(new Úloha(početDam, řádka)));
        }
        fond.shutdown();
        if(fond.awaitTermination(1, TimeUnit.DAYS))
        {
            for (var řešení : výsledky)
            {
                zpracujŘešení(řešení.get());
            }
        }
        else
        {
            System.out.println("Trvá to moc dlouho, končíme");
        }
    }

}
