package program;

import dámy.Řešitel;

import java.util.ArrayList;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

class Přepravka
{
    public int řádka;
    public Přepravka(int řádka)
    {
        this.řádka = řádka;
    }
}

public class Program
{
    public static void zpracujŘešení(int[] pole)
    {
        StringBuilder výpis = new StringBuilder("(");
        for(int i = 0; i < pole.length; i++)
        {
            výpis.append(pole[i]).append(i == pole.length-1? "" : ", ");
        }
        výpis.append(")");
        System.out.println(výpis);
    }

    private static boolean najdiDalšíŘešeníOdŘádky(Přepravka řádka, Řešitel řešitel)
    {
        return řešitel.najdiDalšíŘešeníOdŘádky(řádka.řádka);
    }

    public static void main(String[] param) throws InterruptedException, ExecutionException
    {
        int početDam = 15;
        ArrayList<Future<int[]>> výsledky = new ArrayList<>();
        var fond = Executors.newFixedThreadPool(Runtime.getRuntime().availableProcessors());
        for(int řádka = 0; řádka < početDam; řádka++)
        {
            Přepravka přepravka = new Přepravka(řádka);
            výsledky.add(fond.submit(() -> {
                Řešitel řešitel = new Řešitel(početDam);
                if (najdiDalšíŘešeníOdŘádky(přepravka, řešitel))
                    return řešitel.getŘešení();
                else
                    return null;
            }));
        }
        fond.shutdown();
        if(fond.awaitTermination(1, TimeUnit.DAYS))
        {
            for (var výsledek : výsledky) {
                var řešení = výsledek.get();
                if (řešení != null) {
                    zpracujŘešení(řešení);
                }
            }
        }
        else
        {
            System.out.println("Už mne to nebaví, končíme");
        }
    }
}
